#ifndef __PROG_PARAM__
#define __PROG_PARAM__

#include "Uniform.h"
#include "UniformGLSL.h"

namespace apig {

    // cette classe sert a reprsenter un couple (Uniform, UniformGLSL) :
    class ProgParam {
        public:
            ProgParam(Uniform *value, UniformGLSL *param, bool ownValue) : value(value), param(param), ownValue(ownValue) {}
            // la suppression de <value> est prise en charge si et seulement si <ownValue> == true
            ~ProgParam() { delete param; if (ownValue) delete value; }
            
            void update() const { value->update(param); }
            
        private:
            Uniform *value;
            UniformGLSL *param;
            const bool ownValue;
        };
    
    }

#endif
